# Pygame Zero modunda ekran istenen yerde görüntülenemediği için
# Pygame moduna geçildi.
# Bu kodlar Pygame Modunda çalıştırılmalıdır

# Ekranın doğru yerde görünmesi için gerekli kodlar
import os
x = 0   # Ekranın sol üst köşesinin x koordinatı
y = 50  # Ekranın sol üst köşesinin y koordinatı
os.environ['SDL_VIDEO_WINDOW_POS'] = f'{x},{y}'
import pgzrun
# Dikkat: son satırdaki pgzrun.go() komutu da yazılmış olmalıdır

import random

TITLE= "Hafiza Kartlari" # Ekranın başlığı
SUTUN_SAYISI = 4 # Görsellerin yerleştiği sütun sayısı
SATIR_SAYISI = 3 # Görsellerin yerleştiği satır sayısı
KART_SAYISI=SATIR_SAYISI*SUTUN_SAYISI//2
RKU = 200 # Resim Kenar Uzunluğu
kartlar = [] # Kartlar bu listede tutulacak

eslesme = Actor('eslesme') # Eşleşme olma durumunda kullanılacak kart
arka_yuz = Actor('arka_yuz') # Kartların arka yüzü
guncel_kartlar = [] # Son açılan kart(lar)
eslesen_kartlar = []  # Bulunan kartlar

def kart_destesi_olustur():
    kart_resimleri= []  #Resimler (aslında resim isimleri) bu listede tutulacak
    for i in range(KART_SAYISI):  #Her karttan iki tane resim listesine eklendi
        kart_resimleri.append("resim"+str(i))
        kart_resimleri.append("resim"+str(i))
    random.shuffle(kart_resimleri) #kart resimleri karıldı
    for satir in range(SATIR_SAYISI): # Her bir satirda - (0, 1, 2)
        for sutun in range(SUTUN_SAYISI): # Her bir sütun için - (0, 1, 2, 3)
            cekilen_resim = kart_resimleri.pop() #Son resim alındı
            yeni_kart = Actor(cekilen_resim) # Alınan resimden yeni bir kart oluşturuldu
            yeni_kart.topleft=(sutun*RKU,satir*RKU) # Yeni kartın ekrandaki pozisyonu belirlendi
            kartlar.append(yeni_kart) # Yeni kart kartlar listesine eklendi

kart_destesi_olustur()

def draw():
    screen.clear() # Ekran temizlendi
    for kart in kartlar: #Kartlar ekrana basılma işlemleri
        if kart in eslesen_kartlar: # Eşleşen kartların yerine eşleşme kartını bas
            eslesme.topleft=kart.topleft
            eslesme.draw()
        elif kart in guncel_kartlar: # Son açılan kartları bas
            kart.draw()
        else: # Eşleşmemiş ve açılmamış kartlar için arka yüz kartını bas
            arka_yuz.topleft=kart.topleft
            arka_yuz.draw()
def tiklanan_karti_bul(pos): # Üzerine tıklanan kartı bulup döndürür
    for kart in kartlar:
        if kart.collidepoint(pos):
            return kart

def on_mouse_down(pos,button):
    if len(guncel_kartlar)==2: #İki kart seçilmişse yeni kart seçmeye izin verme
        return
    if button==mouse.LEFT: # Tıklanan karti bul
        tiklanan_kart=tiklanan_karti_bul(pos)
    if tiklanan_kart in eslesen_kartlar: #Daha önce eşleşen kartlar için işlem yapma
        return
    if tiklanan_kart not in guncel_kartlar: #Kartın hali hazırda açık olmadığını kontrol et
        guncel_kartlar.append(tiklanan_kart) # Açık olmayan ve tıklanan kartı Son açılan kartlara ekle
        if len(guncel_kartlar)==2: # Son açılan kart sayısı 2 ise
            if guncel_kartlar[0].image==guncel_kartlar[1].image: # Açılan kartların aynı olması durumunda
                sounds.dogru.play()                              # Ödül sesi çal
                clock.schedule_unique(eslesen_kartlara_ekle,1)   # Açılan kartları 1 sn bulunan kartlar arasına ekle
            else:                     # Açılan kartlar aynı değilse
                sounds.yanlis.play()  # Ceza sesi çal
        clock.schedule_unique(gunceli_sifirla,1) # Son açılan kartları 1 saniye sonra sıfırla

def gunceli_sifirla(): # Son açılan kartları sıfırla
    guncel_kartlar.clear()

def eslesen_kartlara_ekle(): #Açılan kartları bulunan kartlara ekle
   for ikiz_kart in guncel_kartlar:
        eslesen_kartlar.append(ikiz_kart)

pgzrun.go() # Pygame modunda bu komut mutlaka yazılmalıdır
